# coding: utf-8
# Copyright (c) 2016, 2024, Oracle and/or its affiliates.  All rights reserved.
# This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.

# NOTE: This class is auto generated by OracleSDKGenerator. DO NOT EDIT. API Version: 20230831


from oci.util import formatted_flat_dict, NONE_SENTINEL, value_allowed_none_or_none_sentinel  # noqa: F401
from oci.decorators import init_model_state_from_kwargs


@init_model_state_from_kwargs
class MaintenanceWindow(object):
    """
    Details of Maintenance Window.
    """

    #: A constant which can be used with the maintenance_window_type property of a MaintenanceWindow.
    #: This constant has a value of "OPEN_ENDED"
    MAINTENANCE_WINDOW_TYPE_OPEN_ENDED = "OPEN_ENDED"

    #: A constant which can be used with the lifecycle_state property of a MaintenanceWindow.
    #: This constant has a value of "ACTIVE"
    LIFECYCLE_STATE_ACTIVE = "ACTIVE"

    #: A constant which can be used with the lifecycle_state property of a MaintenanceWindow.
    #: This constant has a value of "DELETED"
    LIFECYCLE_STATE_DELETED = "DELETED"

    #: A constant which can be used with the lifecycle_state property of a MaintenanceWindow.
    #: This constant has a value of "FAILED"
    LIFECYCLE_STATE_FAILED = "FAILED"

    #: A constant which can be used with the lifecycle_state property of a MaintenanceWindow.
    #: This constant has a value of "DELETING"
    LIFECYCLE_STATE_DELETING = "DELETING"

    #: A constant which can be used with the lifecycle_state property of a MaintenanceWindow.
    #: This constant has a value of "UPDATING"
    LIFECYCLE_STATE_UPDATING = "UPDATING"

    #: A constant which can be used with the lifecycle_state property of a MaintenanceWindow.
    #: This constant has a value of "NEEDS_ATTENTION"
    LIFECYCLE_STATE_NEEDS_ATTENTION = "NEEDS_ATTENTION"

    def __init__(self, **kwargs):
        """
        Initializes a new MaintenanceWindow object with values from keyword arguments.
        The following keyword arguments are supported (corresponding to the getters/setters of this class):

        :param id:
            The value to assign to the id property of this MaintenanceWindow.
        :type id: str

        :param compartment_id:
            The value to assign to the compartment_id property of this MaintenanceWindow.
        :type compartment_id: str

        :param resource_region:
            The value to assign to the resource_region property of this MaintenanceWindow.
        :type resource_region: str

        :param display_name:
            The value to assign to the display_name property of this MaintenanceWindow.
        :type display_name: str

        :param description:
            The value to assign to the description property of this MaintenanceWindow.
        :type description: str

        :param time_created:
            The value to assign to the time_created property of this MaintenanceWindow.
        :type time_created: datetime

        :param time_updated:
            The value to assign to the time_updated property of this MaintenanceWindow.
        :type time_updated: datetime

        :param maintenance_window_type:
            The value to assign to the maintenance_window_type property of this MaintenanceWindow.
            Allowed values for this property are: "OPEN_ENDED", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type maintenance_window_type: str

        :param is_outage:
            The value to assign to the is_outage property of this MaintenanceWindow.
        :type is_outage: bool

        :param time_schedule_start:
            The value to assign to the time_schedule_start property of this MaintenanceWindow.
        :type time_schedule_start: datetime

        :param duration:
            The value to assign to the duration property of this MaintenanceWindow.
        :type duration: str

        :param is_recurring:
            The value to assign to the is_recurring property of this MaintenanceWindow.
        :type is_recurring: bool

        :param recurrences:
            The value to assign to the recurrences property of this MaintenanceWindow.
        :type recurrences: str

        :param task_initiation_cutoff:
            The value to assign to the task_initiation_cutoff property of this MaintenanceWindow.
        :type task_initiation_cutoff: int

        :param lifecycle_state:
            The value to assign to the lifecycle_state property of this MaintenanceWindow.
            Allowed values for this property are: "ACTIVE", "DELETED", "FAILED", "DELETING", "UPDATING", "NEEDS_ATTENTION", 'UNKNOWN_ENUM_VALUE'.
            Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.
        :type lifecycle_state: str

        :param lifecycle_details:
            The value to assign to the lifecycle_details property of this MaintenanceWindow.
        :type lifecycle_details: str

        :param freeform_tags:
            The value to assign to the freeform_tags property of this MaintenanceWindow.
        :type freeform_tags: dict(str, str)

        :param defined_tags:
            The value to assign to the defined_tags property of this MaintenanceWindow.
        :type defined_tags: dict(str, dict(str, object))

        :param system_tags:
            The value to assign to the system_tags property of this MaintenanceWindow.
        :type system_tags: dict(str, dict(str, object))

        """
        self.swagger_types = {
            'id': 'str',
            'compartment_id': 'str',
            'resource_region': 'str',
            'display_name': 'str',
            'description': 'str',
            'time_created': 'datetime',
            'time_updated': 'datetime',
            'maintenance_window_type': 'str',
            'is_outage': 'bool',
            'time_schedule_start': 'datetime',
            'duration': 'str',
            'is_recurring': 'bool',
            'recurrences': 'str',
            'task_initiation_cutoff': 'int',
            'lifecycle_state': 'str',
            'lifecycle_details': 'str',
            'freeform_tags': 'dict(str, str)',
            'defined_tags': 'dict(str, dict(str, object))',
            'system_tags': 'dict(str, dict(str, object))'
        }

        self.attribute_map = {
            'id': 'id',
            'compartment_id': 'compartmentId',
            'resource_region': 'resourceRegion',
            'display_name': 'displayName',
            'description': 'description',
            'time_created': 'timeCreated',
            'time_updated': 'timeUpdated',
            'maintenance_window_type': 'maintenanceWindowType',
            'is_outage': 'isOutage',
            'time_schedule_start': 'timeScheduleStart',
            'duration': 'duration',
            'is_recurring': 'isRecurring',
            'recurrences': 'recurrences',
            'task_initiation_cutoff': 'taskInitiationCutoff',
            'lifecycle_state': 'lifecycleState',
            'lifecycle_details': 'lifecycleDetails',
            'freeform_tags': 'freeformTags',
            'defined_tags': 'definedTags',
            'system_tags': 'systemTags'
        }

        self._id = None
        self._compartment_id = None
        self._resource_region = None
        self._display_name = None
        self._description = None
        self._time_created = None
        self._time_updated = None
        self._maintenance_window_type = None
        self._is_outage = None
        self._time_schedule_start = None
        self._duration = None
        self._is_recurring = None
        self._recurrences = None
        self._task_initiation_cutoff = None
        self._lifecycle_state = None
        self._lifecycle_details = None
        self._freeform_tags = None
        self._defined_tags = None
        self._system_tags = None

    @property
    def id(self):
        """
        **[Required]** Gets the id of this MaintenanceWindow.
        The OCID of the resource.


        :return: The id of this MaintenanceWindow.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this MaintenanceWindow.
        The OCID of the resource.


        :param id: The id of this MaintenanceWindow.
        :type: str
        """
        self._id = id

    @property
    def compartment_id(self):
        """
        **[Required]** Gets the compartment_id of this MaintenanceWindow.
        Tenancy OCID


        :return: The compartment_id of this MaintenanceWindow.
        :rtype: str
        """
        return self._compartment_id

    @compartment_id.setter
    def compartment_id(self, compartment_id):
        """
        Sets the compartment_id of this MaintenanceWindow.
        Tenancy OCID


        :param compartment_id: The compartment_id of this MaintenanceWindow.
        :type: str
        """
        self._compartment_id = compartment_id

    @property
    def resource_region(self):
        """
        Gets the resource_region of this MaintenanceWindow.
        Associated region


        :return: The resource_region of this MaintenanceWindow.
        :rtype: str
        """
        return self._resource_region

    @resource_region.setter
    def resource_region(self, resource_region):
        """
        Sets the resource_region of this MaintenanceWindow.
        Associated region


        :param resource_region: The resource_region of this MaintenanceWindow.
        :type: str
        """
        self._resource_region = resource_region

    @property
    def display_name(self):
        """
        **[Required]** Gets the display_name of this MaintenanceWindow.
        A user-friendly name. Does not have to be unique, and it's changeable.
        Avoid entering confidential information.

        Example: `My new resource`


        :return: The display_name of this MaintenanceWindow.
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """
        Sets the display_name of this MaintenanceWindow.
        A user-friendly name. Does not have to be unique, and it's changeable.
        Avoid entering confidential information.

        Example: `My new resource`


        :param display_name: The display_name of this MaintenanceWindow.
        :type: str
        """
        self._display_name = display_name

    @property
    def description(self):
        """
        Gets the description of this MaintenanceWindow.
        A user-friendly description. To provide some insight about the resource.
        Avoid entering confidential information.


        :return: The description of this MaintenanceWindow.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this MaintenanceWindow.
        A user-friendly description. To provide some insight about the resource.
        Avoid entering confidential information.


        :param description: The description of this MaintenanceWindow.
        :type: str
        """
        self._description = description

    @property
    def time_created(self):
        """
        **[Required]** Gets the time_created of this MaintenanceWindow.
        The time this resource was created. An RFC3339 formatted datetime string.


        :return: The time_created of this MaintenanceWindow.
        :rtype: datetime
        """
        return self._time_created

    @time_created.setter
    def time_created(self, time_created):
        """
        Sets the time_created of this MaintenanceWindow.
        The time this resource was created. An RFC3339 formatted datetime string.


        :param time_created: The time_created of this MaintenanceWindow.
        :type: datetime
        """
        self._time_created = time_created

    @property
    def time_updated(self):
        """
        Gets the time_updated of this MaintenanceWindow.
        The time this resource was last updated. An RFC3339 formatted datetime string.


        :return: The time_updated of this MaintenanceWindow.
        :rtype: datetime
        """
        return self._time_updated

    @time_updated.setter
    def time_updated(self, time_updated):
        """
        Sets the time_updated of this MaintenanceWindow.
        The time this resource was last updated. An RFC3339 formatted datetime string.


        :param time_updated: The time_updated of this MaintenanceWindow.
        :type: datetime
        """
        self._time_updated = time_updated

    @property
    def maintenance_window_type(self):
        """
        Gets the maintenance_window_type of this MaintenanceWindow.
        Type of the MaintenanceWindow.

        Allowed values for this property are: "OPEN_ENDED", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The maintenance_window_type of this MaintenanceWindow.
        :rtype: str
        """
        return self._maintenance_window_type

    @maintenance_window_type.setter
    def maintenance_window_type(self, maintenance_window_type):
        """
        Sets the maintenance_window_type of this MaintenanceWindow.
        Type of the MaintenanceWindow.


        :param maintenance_window_type: The maintenance_window_type of this MaintenanceWindow.
        :type: str
        """
        allowed_values = ["OPEN_ENDED"]
        if not value_allowed_none_or_none_sentinel(maintenance_window_type, allowed_values):
            maintenance_window_type = 'UNKNOWN_ENUM_VALUE'
        self._maintenance_window_type = maintenance_window_type

    @property
    def is_outage(self):
        """
        **[Required]** Gets the is_outage of this MaintenanceWindow.
        Does the maintenenace window cause outage?


        :return: The is_outage of this MaintenanceWindow.
        :rtype: bool
        """
        return self._is_outage

    @is_outage.setter
    def is_outage(self, is_outage):
        """
        Sets the is_outage of this MaintenanceWindow.
        Does the maintenenace window cause outage?


        :param is_outage: The is_outage of this MaintenanceWindow.
        :type: bool
        """
        self._is_outage = is_outage

    @property
    def time_schedule_start(self):
        """
        Gets the time_schedule_start of this MaintenanceWindow.
        Start time of schedule


        :return: The time_schedule_start of this MaintenanceWindow.
        :rtype: datetime
        """
        return self._time_schedule_start

    @time_schedule_start.setter
    def time_schedule_start(self, time_schedule_start):
        """
        Sets the time_schedule_start of this MaintenanceWindow.
        Start time of schedule


        :param time_schedule_start: The time_schedule_start of this MaintenanceWindow.
        :type: datetime
        """
        self._time_schedule_start = time_schedule_start

    @property
    def duration(self):
        """
        **[Required]** Gets the duration of this MaintenanceWindow.
        Duration if schedule type is Custom


        :return: The duration of this MaintenanceWindow.
        :rtype: str
        """
        return self._duration

    @duration.setter
    def duration(self, duration):
        """
        Sets the duration of this MaintenanceWindow.
        Duration if schedule type is Custom


        :param duration: The duration of this MaintenanceWindow.
        :type: str
        """
        self._duration = duration

    @property
    def is_recurring(self):
        """
        **[Required]** Gets the is_recurring of this MaintenanceWindow.
        Is this is a recurring maintenance window


        :return: The is_recurring of this MaintenanceWindow.
        :rtype: bool
        """
        return self._is_recurring

    @is_recurring.setter
    def is_recurring(self, is_recurring):
        """
        Sets the is_recurring of this MaintenanceWindow.
        Is this is a recurring maintenance window


        :param is_recurring: The is_recurring of this MaintenanceWindow.
        :type: bool
        """
        self._is_recurring = is_recurring

    @property
    def recurrences(self):
        """
        Gets the recurrences of this MaintenanceWindow.
        Recurrence rule specification if recurring


        :return: The recurrences of this MaintenanceWindow.
        :rtype: str
        """
        return self._recurrences

    @recurrences.setter
    def recurrences(self, recurrences):
        """
        Sets the recurrences of this MaintenanceWindow.
        Recurrence rule specification if recurring


        :param recurrences: The recurrences of this MaintenanceWindow.
        :type: str
        """
        self._recurrences = recurrences

    @property
    def task_initiation_cutoff(self):
        """
        **[Required]** Gets the task_initiation_cutoff of this MaintenanceWindow.
        Task initiation cutoff


        :return: The task_initiation_cutoff of this MaintenanceWindow.
        :rtype: int
        """
        return self._task_initiation_cutoff

    @task_initiation_cutoff.setter
    def task_initiation_cutoff(self, task_initiation_cutoff):
        """
        Sets the task_initiation_cutoff of this MaintenanceWindow.
        Task initiation cutoff


        :param task_initiation_cutoff: The task_initiation_cutoff of this MaintenanceWindow.
        :type: int
        """
        self._task_initiation_cutoff = task_initiation_cutoff

    @property
    def lifecycle_state(self):
        """
        **[Required]** Gets the lifecycle_state of this MaintenanceWindow.
        The current state of the MaintenanceWindow.

        Allowed values for this property are: "ACTIVE", "DELETED", "FAILED", "DELETING", "UPDATING", "NEEDS_ATTENTION", 'UNKNOWN_ENUM_VALUE'.
        Any unrecognized values returned by a service will be mapped to 'UNKNOWN_ENUM_VALUE'.


        :return: The lifecycle_state of this MaintenanceWindow.
        :rtype: str
        """
        return self._lifecycle_state

    @lifecycle_state.setter
    def lifecycle_state(self, lifecycle_state):
        """
        Sets the lifecycle_state of this MaintenanceWindow.
        The current state of the MaintenanceWindow.


        :param lifecycle_state: The lifecycle_state of this MaintenanceWindow.
        :type: str
        """
        allowed_values = ["ACTIVE", "DELETED", "FAILED", "DELETING", "UPDATING", "NEEDS_ATTENTION"]
        if not value_allowed_none_or_none_sentinel(lifecycle_state, allowed_values):
            lifecycle_state = 'UNKNOWN_ENUM_VALUE'
        self._lifecycle_state = lifecycle_state

    @property
    def lifecycle_details(self):
        """
        Gets the lifecycle_details of this MaintenanceWindow.
        A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in Failed state.


        :return: The lifecycle_details of this MaintenanceWindow.
        :rtype: str
        """
        return self._lifecycle_details

    @lifecycle_details.setter
    def lifecycle_details(self, lifecycle_details):
        """
        Sets the lifecycle_details of this MaintenanceWindow.
        A message describing the current state in more detail. For example, can be used to provide actionable information for a resource in Failed state.


        :param lifecycle_details: The lifecycle_details of this MaintenanceWindow.
        :type: str
        """
        self._lifecycle_details = lifecycle_details

    @property
    def freeform_tags(self):
        """
        **[Required]** Gets the freeform_tags of this MaintenanceWindow.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :return: The freeform_tags of this MaintenanceWindow.
        :rtype: dict(str, str)
        """
        return self._freeform_tags

    @freeform_tags.setter
    def freeform_tags(self, freeform_tags):
        """
        Sets the freeform_tags of this MaintenanceWindow.
        Simple key-value pair that is applied without any predefined name, type or scope. Exists for cross-compatibility only.
        Example: `{\"bar-key\": \"value\"}`


        :param freeform_tags: The freeform_tags of this MaintenanceWindow.
        :type: dict(str, str)
        """
        self._freeform_tags = freeform_tags

    @property
    def defined_tags(self):
        """
        **[Required]** Gets the defined_tags of this MaintenanceWindow.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :return: The defined_tags of this MaintenanceWindow.
        :rtype: dict(str, dict(str, object))
        """
        return self._defined_tags

    @defined_tags.setter
    def defined_tags(self, defined_tags):
        """
        Sets the defined_tags of this MaintenanceWindow.
        Defined tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"foo-namespace\": {\"bar-key\": \"value\"}}`


        :param defined_tags: The defined_tags of this MaintenanceWindow.
        :type: dict(str, dict(str, object))
        """
        self._defined_tags = defined_tags

    @property
    def system_tags(self):
        """
        Gets the system_tags of this MaintenanceWindow.
        System tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`


        :return: The system_tags of this MaintenanceWindow.
        :rtype: dict(str, dict(str, object))
        """
        return self._system_tags

    @system_tags.setter
    def system_tags(self, system_tags):
        """
        Sets the system_tags of this MaintenanceWindow.
        System tags for this resource. Each key is predefined and scoped to a namespace.
        Example: `{\"orcl-cloud\": {\"free-tier-retained\": \"true\"}}`


        :param system_tags: The system_tags of this MaintenanceWindow.
        :type: dict(str, dict(str, object))
        """
        self._system_tags = system_tags

    def __repr__(self):
        return formatted_flat_dict(self)

    def __eq__(self, other):
        if other is None:
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        return not self == other
